////////////////////////////////////////////////////////////////////////////////
///                            MESH_DrawerCoreVisitor.h                      ///
////////////////////////////////////////////////////////////////////////////////

#ifndef MESH_DRAWER_COREVISITOR_H
#define MESH_DRAWER_COREVISITOR_H

#include <X3DTK/mesh_scenegraph.h>
#include "MESH_DrawerStateVariables.h"

namespace X3DTK {
namespace MESH {

class Transform;

/// Visitor for the Core component of the Drawer processor.

class DrawerCoreVisitor : public CoreVisitor
{
public:
  /// Constructor.
  DrawerCoreVisitor();

  /// Enters a Mesh.
  virtual void enterMesh(Mesh *M) const;

  /// Enters a Transform : push matrix
  virtual void enterTransform(Transform *T) const;

  /// Leaves a Transform : pop matrix
  virtual void leaveTransform(Transform *T) const;

protected:
  DrawerStateVariables *stateVariables;
};

}
}

#endif
