#include "MyMemReleaserGenericAbstractVisitor.h"

#include <iostream>

using namespace X3DTK;
using namespace std;

MyMemReleaserGenericAbstractVisitor::MyMemReleaserGenericAbstractVisitor()
: MemReleaserGenericAbstractVisitor()
{
  // Defines the new enter function for the X3DAbstractNode.
  defineEnterFunction(&MyMemReleaserGenericAbstractVisitor::enterX3DAbstractNode);
  // Defines the new enter function for the Cylinder. This method will not be recorded 
  // because Cylinder doesn't belong to the Abstract component.
  defineEnterFunction(&MyMemReleaserGenericAbstractVisitor::enterCylinder);
}

void MyMemReleaserGenericAbstractVisitor::enterX3DAbstractNode(X3DAbstractNode *N) const
{
  // Prints the name of the node.
  cout << N->getTypeName() << " released " << endl;
  MemReleaserGenericAbstractVisitor::enterX3DAbstractNode(N);
}

void MyMemReleaserGenericAbstractVisitor::enterCylinder(X3D::Cylinder *C) const
{
  // empty because it will never be called.
}

