/// This file is part of the X3DToolKit library
/// Copyright (C) 2002-2003  Yannick Le Goc (legoc@imag.fr)

/// http://www-artis.imag.fr/Members/Yannick.Legoc/X3D/

/// This library is free software; you can redistribute it and/or
/// modify it under the terms of the GNU Lesser General Public
/// License as published by the Free Software Foundation; either
/// version 2.1 of the License, or (at your option) any later version.

/// This library is distributed in the hope that it will be useful,
/// but WITHOUT ANY WARRANTY; without even the implied warranty of
/// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
/// Lesser General Public License for more details.

/// You should have received a copy of the GNU Lesser General Public
/// License along with this library; if not, write to the Free Software
/// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
////////////////////////////////////////////////////////////////////////////////
//                            X3D_X3DAppearanceNode.h                         //
//////////////////////////////////////////////////////////////////////////////// 

#ifndef X3DAPPEARANCENODE_H
#define X3DAPPEARANCENODE_H

#include "X3D_X3DNode.h"

namespace X3DTK {
namespace X3D {

/// Base class of the <a href="../../doc/X3DSpecs/Part01/components/shape.html">Shape 
/// component</a> defining an X3DAppearanceNode
/// (<a href="../../doc/X3DSpecs/Part01/components/Shape.html#X3DAppearanceNode">
/// documentation</a>).


class X3DAppearanceNode : public X3DNode
{
public:
  /// Constructor.
  X3DAppearanceNode();
  /// Virtual destructor.
  virtual ~X3DAppearanceNode();
  
protected:
  /// Copy constructor.
  X3DAppearanceNode(const X3DAppearanceNode &N);
};

}
}

#endif
