#include "X3D_NURBSCreator.h"
#include "X3D_Contour2D.h"
#include "X3D_ContourPolyline2D.h"
#include "X3D_NurbsCurve.h"
#include "X3D_NurbsCurve2D.h"
#include "X3D_NurbsGroup.h"
#include "X3D_NurbsPositionInterpolator.h"
#include "X3D_NurbsSurface.h"
#include "X3D_NurbsTextureSurface.h"
#include "X3D_TrimmedSurface.h"

namespace X3DTK {
namespace X3D {

NURBSCreator::NURBSCreator()
{
  defineComponentName("NURBS", "X3D");

  defineNode<Contour2D>();
  defineNode<ContourPolyline2D>();
  defineNode<NurbsCurve>();
  defineNode<NurbsCurve2D>();
  defineNode<NurbsGroup>();
  defineNode<NurbsPositionInterpolator>();
  defineNode<NurbsSurface>();
  defineNode<NurbsTextureSurface>();
  defineNode<TrimmedSurface>();
}

NURBSCreator::~NURBSCreator()
{
}

}
}
