#include "X3D_Group.h"

namespace X3DTK {
namespace X3D {

Group::Group()
: X3DGroupingNode(), X3DBoundedObject()
{
  defineTypeName("Group", "Grouping");
}

Group::Group(const SFVec3f &bboxCenter, const SFVec3f &bboxSize)
: X3DGroupingNode(), X3DBoundedObject(bboxCenter, bboxSize)
{
  defineTypeName("Group", "Grouping");
}

Group::Group(const Group &G)
: X3DGroupingNode(G), X3DBoundedObject(G)
{
}

SFAbstractNode Group::clone() const
{
  return new Group(*this);
}

Group::~Group()
{
}

void Group::load(const X3DFileElement *element)
{ 
  X3DBoundedObject::load(element);
}

SFString &Group::write(SFString &output) const
{
  return X3DBoundedObject::write(output);
}

}
}
