#include "GL_RendererTexturingVisitor.h"
#include "GL_ImageTexture.h"

namespace X3DTK {
namespace GL {

RendererTexturingVisitor::RendererTexturingVisitor()
: TexturingVisitor()
{
  // Enter functions.
  defineEnterFunction(&RendererTexturingVisitor::enterImageTexture);

  // StateVariables assignation.
  stateVariables = GraphTraversal::getInstanceOf<RendererStateVariables>();
}

RendererTexturingVisitor::~RendererTexturingVisitor()
{
}

void RendererTexturingVisitor::enterImageTexture(ImageTexture *I) const
{
  glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
  glBindTexture(GL_TEXTURE_2D, I->getTexName());
  
  glMatrixMode(GL_TEXTURE);
  glLoadMatrixf(I->getTextureTransform());
}

}
}
