#include "MESH_MeshVerticesDrawerStateVariables.h"
#include <iostream>

using namespace std;

namespace X3DTK {
namespace MESH {

MeshVerticesDrawerStateVariables::MeshVerticesDrawerStateVariables()
: StateVariables(), _selectionMode(false), _oneColorPerMesh(true)
{}

void MeshVerticesDrawerStateVariables::init()
{
  _matrixStack.push_front(SFMatrix34f::identity);
}

void MeshVerticesDrawerStateVariables::finish()
{
  _matrixStack.pop_front();
  if (_matrixStack.size() != 0)
  {
    cx3d << "MeshVerticesDrawerStateVariables::finishTraversal: Non empty matrix stack at the end of MeshVerticesDrawer traversal" << endl;
    _matrixStack.clear();
  }
  
  _matrixVector.clear();
  _meshVector.clear();
}

void MeshVerticesDrawerStateVariables::pushMatrix(const SFMatrix34f &transformation)
{
  _matrixStack.push_front(_matrixStack.front()*transformation);
}

void MeshVerticesDrawerStateVariables::popMatrix()
{
  _matrixStack.pop_front();
}

void MeshVerticesDrawerStateVariables::storeMesh(Mesh *mesh)
{
  _matrixVector.push_back(_matrixStack.front());
  _meshVector.push_back(mesh);
}

int MeshVerticesDrawerStateVariables::getCurrentMeshId()
{
  return _matrixVector.size() - 1;
}

}
}
