/// This file is part of the X3DToolKit library
/// Copyright (C) 2002-2003  Yannick Le Goc (legoc@imag.fr)

/// http://www-artis.imag.fr/Members/Yannick.Legoc/X3D/

/// This library is free software; you can redistribute it and/or
/// modify it under the terms of the GNU Lesser General Public
/// License as published by the Free Software Foundation; either
/// version 2.1 of the License, or (at your option) any later version.

/// This library is distributed in the hope that it will be useful,
/// but WITHOUT ANY WARRANTY; without even the implied warranty of
/// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
/// Lesser General Public License for more details.

/// You should have received a copy of the GNU Lesser General Public
/// License along with this library; if not, write to the Free Software
/// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
////////////////////////////////////////////////////////////////////////////////
//                            MESH_MeshX3DBuilder.h                               //
////////////////////////////////////////////////////////////////////////////////

#ifndef MESHX3DBUILDER_H
#define MESHX3DBUILDER_H

#include "MESH_SceneGraphTypes.h"
#include "X3DOnePassProcessor.h"
#include "MESH_MeshX3DBuilderStateVariables.h"

namespace X3DTK {
namespace X3D {

class Scene;

}

namespace MESH {

class Scene;

/// Processor building the X3D scene graph from the MESH scene graph.

class MeshX3DBuilder : public X3DOnePassProcessor
{
public:
  MeshX3DBuilder();
  virtual ~MeshX3DBuilder();
  
  /// Builds the X3D graph scene from the MESH.
  virtual X3D::SFNode build(SFNode N);
  /// Builds the X3D scene from the MESH scene.
  X3D::Scene *build(Scene *S);
  
protected:  
  MeshX3DBuilderStateVariables *stateVariables;
};

}
}

#endif

