#include "X3D_GLBuilderTexturingVisitor.h"
#include "X3D_ImageTexture.h"
#include "GL_ImageTexture.h"

namespace X3DTK {
namespace X3D {

GLBuilderTexturingVisitor::GLBuilderTexturingVisitor()
: TexturingVisitor()
{
  // Enter functions.
  defineEnterFunction(&GLBuilderTexturingVisitor::enterImageTexture);

  // StateVariables assignation.
  stateVariables = GraphTraversal::getInstanceOf<GLBuilderStateVariables>();
}

GLBuilderTexturingVisitor::~GLBuilderTexturingVisitor()
{
}

void GLBuilderTexturingVisitor::enterImageTexture(ImageTexture *I) const
{
  GL::ImageTexture *GI = new GL::ImageTexture();
  GI->setX3DReference(I);
  stateVariables->getTop()->addChild(GI);
  stateVariables->pushNode(GI);
}

}
}
