/// This file is part of the X3DToolKit library
/// Copyright (C) 2002-2003  Yannick Le Goc (legoc@imag.fr)

/// http://www-artis.imag.fr/Members/Yannick.Legoc/X3D/

/// This library is free software; you can redistribute it and/or
/// modify it under the terms of the GNU Lesser General Public
/// License as published by the Free Software Foundation; either
/// version 2.1 of the License, or (at your option) any later version.

/// This library is distributed in the hope that it will be useful,
/// but WITHOUT ANY WARRANTY; without even the implied warranty of
/// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
/// Lesser General Public License for more details.

/// You should have received a copy of the GNU Lesser General Public
/// License along with this library; if not, write to the Free Software
/// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
////////////////////////////////////////////////////////////////////////////////
//                            X3D_TemplateMeshBuilderTraits.h                 //
////////////////////////////////////////////////////////////////////////////////

#ifndef TEMPLATEMESHBUILDERTRAITS_H
#define TEMPLATEMESHBUILDERTRAITS_H

namespace X3DTK {
namespace X3D {

/// Traits class to enable partial specialization of the start, processNewFace and end 
/// functions of the TemplateMeshBuilder processor.

template<class MData, class VData, class EData, class FData, class T>
struct TemplateMeshBuilderGeometryTraits
{
  /// Start function.
  static void init(MESH::TemplateMesh<MData, VData, EData, FData> *mesh, T *N) {};
  /// processNewFace function.
  static void processNewFace(MESH::TemplateMesh<MData, VData, EData, FData> *mesh, T *N, MESH::SFTemplateFace<FData, VData, EData> *F) {};
  /// End function.
  static void finish(MESH::TemplateMesh<MData, VData, EData, FData> *mesh, T *N) {};
};

template<class VData, class EData, class FData, class T>
struct TemplateMeshBuilderCoordinateTraits
{
  /// Process function.
  static void process(MESH::TemplateVertexSet<VData, EData, FData> *vertexSet, T *N) {};
};


}
}

#endif
