#include "X3D_WorldCoordTranslator.h"
#include "X3D_WorldCoordTranslatorGroupingVisitor.h"
#include "X3D_WorldCoordTranslatorRenderingVisitor.h"
#include "X3D_DFSGraphTraversal.h"
#include "X3D_X3DNode.h"

namespace X3DTK {
namespace X3D {

WorldCoordTranslator::WorldCoordTranslator()
{
  stateVariables = GraphTraversal::getInstanceOf<WorldCoordTranslatorStateVariables>();
    
  graphTraversal = new DFSGraphTraversal();
  graphTraversal->setComponentVisitor(new WorldCoordTranslatorGroupingVisitor());
  graphTraversal->setComponentVisitor(new WorldCoordTranslatorRenderingVisitor());
}

WorldCoordTranslator::~WorldCoordTranslator()
{
  GraphTraversal::removeInstanceOf<WorldCoordTranslatorStateVariables>();

  delete graphTraversal;
}

void WorldCoordTranslator::translate(SFNode N)
{
  stateVariables->init();
  graphTraversal->traverse(N);
  stateVariables->finish();
}

}
}
