#include "X3D_WorldCoordTranslatorStateVariables.h"

namespace X3DTK {
namespace X3D {

WorldCoordTranslatorStateVariables::WorldCoordTranslatorStateVariables()
: StateVariables()
{
}

WorldCoordTranslatorStateVariables::~WorldCoordTranslatorStateVariables()
{
}

void WorldCoordTranslatorStateVariables::init()
{
  _matrixStack.push_front(SFMatrix34f::identity);
}

void WorldCoordTranslatorStateVariables::finish()
{
  _matrixStack.clear();
}

void WorldCoordTranslatorStateVariables::pushMatrix(const SFMatrix34f &transformation)
{
  _matrixStack.push_front(_matrixStack.front()*transformation);
}

void WorldCoordTranslatorStateVariables::popMatrix()
{
  _matrixStack.pop_front();
}

}
}
