#include "X3DMultiPassProcessor.h"

using namespace std;

namespace X3DTK {

X3DMultiPassProcessor::X3DMultiPassProcessor()
: X3DProcessor()
{
}

X3DMultiPassProcessor::~X3DMultiPassProcessor()
{
}
  
void X3DMultiPassProcessor::setComponentWalker(const SFString &processor, X3DComponentWalker *component)
{
  GraphTraversal *graphTraversal = getGraphTraversalOf(processor);
  if (graphTraversal != 0)
    graphTraversal->setComponentWalker(component);
}

void X3DMultiPassProcessor::setComponentVisitor(const SFString &processor, X3DComponentVisitor *component)
{
  GraphTraversal *graphTraversal = getGraphTraversalOf(processor);
  if (graphTraversal != 0)
    graphTraversal->setComponentVisitor(component);
}

GraphTraversal *X3DMultiPassProcessor::getGraphTraversalOf(const SFString &processor) const
{
  MGraphTraversal::const_iterator it = graphTraversalMap.find(processor); 
  if (it != graphTraversalMap.end())
    return (*it).second;
    
  //the GraphTraversal doesn't exist.
  return 0;  
}
  
}
